# -*- coding: UTF-8 -*-


from __future__ import with_statement
from path import path
import es
import playerlib
import cPickle

ROUNDS_NEEDED = 45
filepath = path(__file__).parent.joinpath('player_rounds.db')
player_rounds = {}

with filepath.open('rb') as f:
   try:
      player_rounds = cPickle.load(f)
   except EOFError:
      player_rounds = {}


# Events
def load():
   for userid in es.getUseridList():
      sid = es.getplayersteamid(userid)
      if not sid in player_rounds:
         player_rounds[sid] = 0

def unload():
   save_db()
   es.addons.unregisterClientCommandFilter(joinFilter) 

def es_map_start(event_var):
   save_db()

def save_db():
   with filepath.open('wb') as f:
      cPickle.dump(player_rounds, f)    

def player_activate(event_var):
   steamid = event_var['es_steamid']
   if not steamid in player_rounds:
      player_rounds[steamid] = 0

def round_end(event_var):
   for userid in playerlib.getPlayerList('#t'):
      player_rounds[es.getplayersteamid(userid)] += 1

def joinFilter(userid, args):
   if args[0].lower() == 'jointeam':
      if int(args[1]) == 3 and player_rounds[es.getplayersteamid(userid)] < ROUNDS_NEEDED:
         es.tell(userid, '#multi', '#greenDu musst mindestens #darkgreen%s #greenRunden als Terrorist gespielt haben bevor du Counter-Terrorist spielen kannst! Dir fehlen noch #darkgreen%s #greenRunden' %(ROUNDS_NEEDED, ROUNDS_NEEDED-player_rounds[es.getplayersteamid(userid)]))
         return False
   return True

es.addons.registerClientCommandFilter(joinFilter)